﻿
using UnityEngine;
using System;

namespace Mod
{
	public class Mod : MonoBehaviour
	{
		public static Nailgun nailgun;
		public struct MySettings
        {
        

			/*[SettingTitle("Animated Catalog")]
			[SettingDesc("If the catalog icons with animations play their animations")]*/
			public bool animatedCatalog;
        }
		public static MySettings settings;

		public static void OnLoad()
		{
			nailgun = new Nailgun();
			Debug.Log("OnLoad called");
			settings = new MySettings
			{
				animatedCatalog = true
            };
			/*string settingsPath = "Polars Bear Random Syringes.cfg";
			try
			{
				StreamReader reader = new StreamReader(settingsPath);
				string raw = reader.ReadToEnd();
				reader.Close();
				settings = JsonConvert.DeserializeObject<MySettings>(raw);
				reader.Close();
			}
			catch (FileNotFoundException)
			{
				StreamWriter writer = new StreamWriter(settingsPath);
				writer.Write(JsonConvert.SerializeObject(settings));
				writer.Close();
			}*/

			/*ModSettingManager manager = ModSettingManager.Load();
			modSettings = new ModSettings(settings,"config",ModAPI.Metadata);
			settings = modSettings.ReadSettings<MySettings>();
			
			//manager.Add(modSettings);*/
		}

		public static void Main()
		{
			bool found = false;
			foreach (Category cat in CatalogBehaviour.Main.Catalog.Categories)
			{
				if (cat.name == "Polars Bear")
				{
					found = true;
				}
			}
			if (!found)
			{
				CategoryBuilder.Create("Polars Bear", "Polars Bear creations", ModAPI.LoadSprite("sprites/bear.png"));
			}
			nailgun.NailgunConstruct();
			AutoLoad.LoadScripts();
		}

		public static bool RegenerateWounds(SkinMaterialHandler skin, float factor)
		{
			float num = Mathf.Pow(0.95f, factor);
			float num2 = Mathf.Pow(0.95f, factor);
			float num3 = Mathf.Pow(0.97f, factor);
			bool result = false;
			for (int i = 0; i < 128; i++)
			{
				DamagePoint damagePoint = skin.damagePoints[i];
				switch (damagePoint.Type)
				{
					case DamageType.Blunt:
						if (damagePoint.Intensity > 0.001f)
						{
							Vector4[] array = skin.damagePoints;
							int num4 = i;
							array[num4].z = array[num4].z * num;
							result = true;
						}
						break;
					case DamageType.Bullet:
					case DamageType.Stab:
						if (damagePoint.Intensity > 0.001f)
						{
							Vector4[] array2 = skin.damagePoints;
							int num5 = i;
							array2[num5].z = array2[num5].z * num2;
							result = true;
						}
						break;
					case DamageType.Burn:
						if (damagePoint.Intensity > 0.001f)
						{
							Vector4[] array3 = skin.damagePoints;
							int num6 = i;
							array3[num6].z = array3[num6].z * num3;
							result = true;
						}
						break;
				}
			}
			return result;
		}
	}
}