﻿using System;
using System.Collections;
using System.Reflection;
using UnityEngine;

namespace Mod
{
    public class BigBoiSyringe : SyringeBehaviour
    {
        public const string name = "​<b></b>" + "</size>Big Boi Syringe";
        public static void Load()
        {
            ModAPI.RegisterLiquid(BigBoiSyringeSerum.ID, new BigBoiSyringeSerum());

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Acid Syringe"),

                    NameOverride = name,
                    DescriptionOverride = "Syringe that makes the boi big.",

                    CategoryOverride = ModAPI.FindCategory("Polars Bear"),
                    AfterSpawn = (Instance) => { Destroy(Instance.GetComponent<SyringeBehaviour>()); Instance.GetOrAddComponent<BigBoiSyringe>(); }
                }
            );
            Mod.nailgun.SyringeNail(name, typeof(BigBoiSyringe));
        }
        public override string GetLiquidID() => BigBoiSyringeSerum.ID;
        public class BigBoiSyringeSerum : Liquid
        {
            public const string ID = "​<b></b>" + "BIG BOI SERUM";
            public const float TransferRate = 0f;


            public BigBoiSyringeSerum()
            {
                Color = new UnityEngine.Color(0f,0.6f,0f);
            }
            public override void OnEnterLimb(LimbBehaviour limby)
            {
                if (limby.SpeciesIdentity == "Android")
                {
                    return;
                }
                limby.CirculationBehaviour.RemoveLiquid(this, limby.CirculationBehaviour.GetAmount(this));
                if (!limby.GetComponent<Injected>())
                {
                    limby.gameObject.AddComponent<Injected>();
                    limby.Person.transform.localScale = limby.Person.transform.localScale * 1.25f;
                    foreach (LimbBehaviour limb in limby.Person.Limbs)
                    {
                        limb.CirculationBehaviour.RemoveLiquid(this, limb.CirculationBehaviour.GetAmount(this));
                        limby.BaseStrength = limby.BaseStrength * 1.25f;
                    }
                }
            }
            public override void OnExitContainer(BloodContainer container) { }
            public override void OnUpdate(BloodContainer container) { }
            public override void OnEnterContainer(BloodContainer container) { }
           
            private class Injected : MonoBehaviour
            {
                private float timer = 3f;
                void Update()
                {
                    timer -= Time.deltaTime;
                    if (timer <= 0)
                    {
                        Destroy(this);
                    }
                }
            }
        }

    }
}

//Author: Polars Bear
