﻿using System;
using System.Collections;
using System.Reflection;
using UnityEngine;

namespace Mod
{
	public class FleshySyringe : SyringeBehaviour
	{
		public const string name = "​<b></b>" + "Fleshy Syringe";
		public static void Load()
		{
			ModAPI.RegisterLiquid(FleshySyringe.FleshyFluid.ID, new FleshySyringe.FleshyFluid());
			ModAPI.Register(
				new Modification()
				{
					OriginalItem = ModAPI.FindSpawnable("Acid Syringe"),

					NameOverride = name,
					DescriptionOverride = "<i>Meat is back on the menu, boys!</i> Reveals the flesh of the victim.",

					CategoryOverride = ModAPI.FindCategory("Polars Bear"),
					AfterSpawn = (Instance) => { Destroy(Instance.GetComponent<SyringeBehaviour>()); Instance.GetOrAddComponent<FleshySyringe>(); }
				}
			);
			Mod.nailgun.SyringeNail(name, typeof(FleshySyringe));
		}
		public override string GetLiquidID() => FleshyFluid.ID;
		public class FleshyFluid : Liquid
		{
			public const string ID = "​<b></b>" + "FLESHY-IZATION FLUID";
			public FleshyFluid()
			{
				Color = new Color(1.00000f, 0.31373f, 0.31373f);
			}
			public override void OnEnterLimb(LimbBehaviour limb)
			{
				limb.gameObject.GetOrAddComponent<Fleshy>();
				//limb.SkinMaterialHandler.renderer.material.SetFloat(ShaderProperties.Get("_AcidProgress"), 1f);
			}
			public override void OnExitContainer(BloodContainer container) { }
			public override void OnUpdate(BloodContainer container) { }
			public override void OnEnterContainer(BloodContainer container) { }

			public class Fleshy : MonoBehaviour
			{
				public LimbBehaviour limb;
				public SkinMaterialHandler skin;
				private float from;
				float original;
				void Awake()
				{
					limb = GetComponent<LimbBehaviour>();
					skin = limb.SkinMaterialHandler;
					original = skin.renderer.material.GetFloat(ShaderProperties.Get("_AcidProgress"));
					from = original;
				}
				void OnWillRenderObject()
				{
					skin.renderer.material.SetFloat(ShaderProperties.Get("_AcidProgress"), Math.Min(from, 0.7f));
					if (from < 1f)
					{
						from = Math.Min(0.7f, skin.renderer.material.GetFloat(ShaderProperties.Get("_AcidProgress")) + (0.5f * Time.deltaTime));
					}
				}

				void OnDestroy()
                {
					skin.renderer.material.SetFloat(ShaderProperties.Get("_AcidProgress"), skin.AcidProgress);
				}

			}
		}

	}
}

//Template by Polars Bear
