﻿using System;
using System.Collections;
using System.Reflection;
using UnityEngine;

namespace Mod
{
    public class HeadPoppingSyringe : SyringeBehaviour
    {
        public const string name = "​<b></b>" + "Head Popping Syringe";
        public static void Load()
        {
            ModAPI.RegisterLiquid(HeadPoppingSyringeSerum.ID, new HeadPoppingSyringeSerum());

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Acid Syringe"),

                    NameOverride = name,
                    DescriptionOverride = "Syringe that makes the head of the user go kaboom.",

                    CategoryOverride = ModAPI.FindCategory("Polars Bear"),
                    AfterSpawn = (Instance) => { Destroy(Instance.GetComponent<SyringeBehaviour>()); Instance.GetOrAddComponent<HeadPoppingSyringe>(); }
                }
            );
            Mod.nailgun.SyringeNail(name, typeof(HeadPoppingSyringe));
        }
        public override string GetLiquidID() => HeadPoppingSyringeSerum.ID;

        public class HeadPoppingSyringeSerum : libs.OneTimeBodyLiquid
        {
            public const string ID = "​<b></b>" + "HEAD POPPING SERUM";
            public HeadPoppingSyringeSerum()
            {
                Color = new Color(0.2f, 0.3f, 1f);
            }
            public override void OnEnterLimb(LimbBehaviour limb)
            {
                base.OnEnterLimb(limb);
                LimbBehaviour head = limb.Person.Limbs[0];
                head.gameObject.GetOrAddComponent<ExplodeHead>();
            }
        }

        class ExplodeHead : MonoBehaviour
        {
            LimbBehaviour head;
            void Start()
            {
                head = GetComponent<LimbBehaviour>();
                var c = head.Color;
                c.a = 0f;
                head.Color = c;
                head.Collider.enabled = false;
                for (int i = 0; i < 3; i++)
                    ModAPI.CreateParticleEffect("BloodExplosion", head.transform.position).GetComponent<BloodExplosionBehaviour>().SetColor(head.CirculationBehaviour.GetComputedColor());
            }

            void OnDestroy()
            {
                var c = head.Color;
                c.a = 1f;
                head.Color = c;
                head.Collider.enabled = true;
            }
        }
    }
}

//Author: Polars Bear
