﻿using System;
using System.Collections;
using System.Reflection;
using UnityEngine;

namespace Mod
{
    public class PanicSyringe : SyringeBehaviour
    {
        public const string name = "​<b></b>" + "Panic Syringe";
        public static void Load()
        {
            ModAPI.RegisterLiquid(PanicSyringeSerum.ID, new PanicSyringeSerum());

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Acid Syringe"),

                    NameOverride = name,
                    DescriptionOverride = "Syringe that randomly causes panic over the course of 10 seconds.",

                    CategoryOverride = ModAPI.FindCategory("Polars Bear"),
                    AfterSpawn = (Instance) => { Destroy(Instance.GetComponent<SyringeBehaviour>()); Instance.GetOrAddComponent<PanicSyringe>(); }
                }
            );
            Mod.nailgun.SyringeNail(name, typeof(PanicSyringe));
        }
        public override string GetLiquidID() => PanicSyringeSerum.ID;
        public class PanicSyringeSerum : libs.OneTimeBodyLiquid
        {
            public const string ID = "​<b></b>" + "PANIC AGENT";
            public PanicSyringeSerum()
            {
                Color = new Color(0.40000f, 0.40000f, 0.60000f);
            }
            public override void OnEnterLimb(LimbBehaviour limb)
            {
                base.OnEnterLimb(limb);
                limb.gameObject.GetOrAddComponent<Panic>();
            }

            public class Panic : MonoBehaviour
            {
                float timer05 = 0f;
                PersonBehaviour person;
                void Start()
                {
                    person = GetComponent<LimbBehaviour>().Person;
                }
                void Update()
                {
                    timer05 += Time.deltaTime;

                    while (timer05 >= 0.5f)
                    {
                        timer05 -= 0.5f;
                        person.ShockLevel = UnityEngine.Random.Range(0.5f, 1f);
                        person.PainLevel = UnityEngine.Random.Range(0.5f, 1f);
                    }
                }
            }
        }
    }
}

//Author: Polars Bear
