﻿using System;
using System.Collections;
using System.Reflection;
using UnityEngine;

namespace Mod
{
    public class PropSyringe : SyringeBehaviour
    {
        public const string name = "​<b></b>" + "Prop Syringe";
        public PhysicalBehaviour phys;
        public FieldInfo contactBuffer = typeof(PhysicalBehaviour).GetField("contactBuffer");
        public MethodInfo IsPointNearLooseSharpEnd = typeof(PhysicalBehaviour).GetMethod("IsPointNearLooseSharpEnd");
        public FieldInfo previousVelocity = typeof(PhysicalBehaviour).GetField("previousVelocity");
        public MethodInfo DoStab = typeof(PhysicalBehaviour).GetMethod("DoStab");
        public static void Load()
        {
            /*ModAPI.RegisterLiquid(PropSyringeSerum.ID, new PropSyringeSerum());

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Acid Syringe"),

                    NameOverride = name,
                    DescriptionOverride = "Syringe that turns the user into a prop.",

                    CategoryOverride = ModAPI.FindCategory("Polars Bear"),
                    AfterSpawn = (Instance) => { Destroy(Instance.GetComponent<SyringeBehaviour>()); Instance.GetOrAddComponent<PropSyringe>(); }
                }
            );
            Mod.nailgun.SyringeNail(name, typeof(PropSyringe));*/
        }
        public override string GetLiquidID() => PropSyringeSerum.ID;

        /*void OnCollisionEnter2D(Collision2D collision)
        {
            PhysicalBehaviour physicalBehaviour;
            if (!Global.main.PhysicalObjectsInWorldByTransform.TryGetValue(collision.transform, out physicalBehaviour))
            {
                return;
            }
            if (collision.relativeVelocity.magnitude / phys.Properties.SharpForceThresholdMultiplier < 5f / (1f + 1f * 3f))
            {
                return;
            }
            int contacts = collision.GetContacts((ContactPoint2D[])contactBuffer.GetValue(phys));
            ContactPoint2D contact = Utils.GetFirstValidContact((ContactPoint2D[])contactBuffer.GetValue(phys), contacts);
            if (!(bool)IsPointNearLooseSharpEnd.Invoke(phys,new object[] { contact.point }))
            {
                return;
            }
            Vector2 normalized = collision.relativeVelocity.normalized;
            if (Vector2.Dot(contact.normal, normalized) < -0.98f)
            {
                return;
            }
            PhysicalBehaviour.Penetration penetration = new PhysicalBehaviour.Penetration();
            penetration.Stabber = phys;
            bool flag = false;
            SharpAxis sharpAxis = default(SharpAxis);
            foreach (SharpAxis sharpAxis2 in phys.Properties.SharpAxes)
            {
                Vector3 v = base.transform.TransformVector(sharpAxis2.Axis);
                if (Vector2.Dot(normalized, v) < -0.92f && Vector2.Dot(contact.normal, v) < -0.3f)
                {
                    sharpAxis = sharpAxis2;
                    penetration.Axis = sharpAxis;
                    flag = true;
                    break;
                }
            }
            if (!flag)
            {
                return;
            }
            if (!penetration.Active)
            {
                FieldInfo otherPreviousVelocity = physicalBehaviour.GetType().GetField("previousVelocity");
                penetration.Active = true;
                penetration.Duration = 0f;
                phys.rigidbody.velocity = (Vector2)previousVelocity.GetValue(phys);
                if (physicalBehaviour.rigidbody.bodyType == RigidbodyType2D.Dynamic)
                {
                    physicalBehaviour.rigidbody.velocity = (Vector2)otherPreviousVelocity.GetValue(physicalBehaviour);
                }
                Vector2 vector = contact.point;
                vector = collision.collider.ClosestPoint(vector);
                Stabbing stabbing = new Stabbing(phys, physicalBehaviour, contact.normal, vector);
                physicalBehaviour.SendMessage("Stabbed", stabbing, SendMessageOptions.DontRequireReceiver);
                gameObject.SendMessage("Lodged", stabbing, SendMessageOptions.DontRequireReceiver);
                penetration.CurrentConnectedAnchor = physicalBehaviour.transform.InverseTransformPoint(vector);
                DoStab.Invoke(phys, new object[] { physicalBehaviour, sharpAxis, penetration });
            }
        }

        void Awake()
        {
            base.Awake();
            phys = GetComponent<PhysicalBehaviour>();
        }*/

        public override void Lodged(Stabbing stabbing)
        {
            base.Lodged(stabbing);
            GameObject obj = stabbing.victim.gameObject;
            while (obj.transform.parent)
            {
                obj = obj.transform.parent.gameObject;
            }
            if (obj.name == "WORLD") { return; }
            obj.GetOrAddComponent<TurnProp>();
        }

        private class TurnProp : MonoBehaviour
        {
            GameObject obj;
            void Awake()
            {
                obj = Instantiate(CatalogBehaviour.Main.Catalog.Items.PickRandom().Prefab);

                obj.transform.position = transform.position;
                obj.transform.rotation = transform.rotation;
                obj.transform.localScale *= UnityEngine.Random.Range(0.9f, 1.1f);

                Destroy(gameObject);
            }
        }

        public class PropSyringeSerum : Liquid
        {
            public const string ID = "​<b></b>" + "PROP SERUM";
            public PropSyringeSerum()
            {
                Color = new UnityEngine.Color(0.72549f, 0.38824f, 0.27451f);
            }
            public override void OnEnterLimb(LimbBehaviour limb)
            {
            }
            public override void OnExitContainer(BloodContainer container) { }
            public override void OnUpdate(BloodContainer container) { }
            public override void OnEnterContainer(BloodContainer container) { }
            
            
        }

    }
}

//Author: Polars Bear
