﻿using System;
using System.Collections;
using System.Reflection;
using UnityEngine;

namespace Mod
{
	public class RotSyringe : SyringeBehaviour
	{
		public const string name = "​<b></b>" + "Rot Syringe";
		public static void Load()
		{
			ModAPI.RegisterLiquid(RotSyringe.DecompositionAgent.ID, new RotSyringe.DecompositionAgent());
			ModAPI.Register(
				new Modification()
				{
					OriginalItem = ModAPI.FindSpawnable("Acid Syringe"),

					NameOverride = name,
					DescriptionOverride = "Syringe that makes the user quickly rot.",

					CategoryOverride = ModAPI.FindCategory("Polars Bear"),
					AfterSpawn = (Instance) => { Destroy(Instance.GetComponent<SyringeBehaviour>()); Instance.GetOrAddComponent<RotSyringe>(); }
				}
			);
			Mod.nailgun.SyringeNail(name, typeof(RotSyringe));
		}
		public override string GetLiquidID() => DecompositionAgent.ID;
		public class DecompositionAgent : Liquid
		{
			public const string ID = "​<b></b>" + "DECOMPOSITION AGENT";
			public DecompositionAgent()
			{
				Color = new UnityEngine.Color(0.56863f, 0.56863f, 0.00000f);
			}
			public override void OnEnterLimb(LimbBehaviour limb)
			{
				limb.CirculationBehaviour.StartCoroutine(this.RapidRottingPB(limb));
			}
			public override void OnExitContainer(BloodContainer container) { }
			public override void OnUpdate(BloodContainer container) { }
			public override void OnEnterContainer(BloodContainer container) { }
			private IEnumerator RapidRottingPB(LimbBehaviour limb)
			{
				SkinMaterialHandler skin = limb.SkinMaterialHandler;
				while (skin.RottenProgress < 1f)
				{
					skin.RottenProgress = Math.Min(skin.RottenProgress + 0.2f * Time.deltaTime, 1f);
					yield return new WaitForEndOfFrame();
				}
			}
		}

	}
}
