﻿using System;
using System.Collections;
using System.Reflection;
using UnityEngine;

namespace Mod
{
	public class SkeletonSyringe : SyringeBehaviour
	{
		public const string name = "​<b></b>" + "Skeleton Syringe";
		public static void Load()
		{
			ModAPI.RegisterLiquid(SkeletonSyringe.SkeletonFluid.ID, new SkeletonSyringe.SkeletonFluid());
			ModAPI.Register(
				new Modification()
				{
					OriginalItem = ModAPI.FindSpawnable("Acid Syringe"),

					NameOverride = name,
					DescriptionOverride = "<i>Spooky Scary Skeletons!</i> Do I even need to say anything else?",

					CategoryOverride = ModAPI.FindCategory("Polars Bear"),
					AfterSpawn = (Instance) => { Destroy(Instance.GetComponent<SyringeBehaviour>()); Instance.GetOrAddComponent<SkeletonSyringe>(); }
				}
			);
			Mod.nailgun.SyringeNail(name, typeof(SkeletonSyringe));
		}
		public override string GetLiquidID() => SkeletonFluid.ID;
		public class SkeletonFluid : Liquid
		{

			public const string ID = "​<b></b>" + "SKELETON-IZATION FLUID";
			public SkeletonFluid()
			{
				Color = new Color(1.00000f, 1.00000f, 0.80000f);
			}
			public override void OnEnterLimb(LimbBehaviour limb)
			{
				limb.gameObject.GetOrAddComponent<Skelly>();
				//limb.SkinMaterialHandler.renderer.material.SetFloat(ShaderProperties.Get("_AcidProgress"), 1f);
			}
			public override void OnExitContainer(BloodContainer container) { }
			public override void OnUpdate(BloodContainer container) { }
			public override void OnEnterContainer(BloodContainer container) { }

			public class Skelly : MonoBehaviour
			{
				public LimbBehaviour limb;
				public SkinMaterialHandler skin;
				private float from;
				float original;
				void Awake()
				{
					limb = GetComponent<LimbBehaviour>();
					skin = limb.SkinMaterialHandler;
					original = skin.renderer.material.GetFloat(ShaderProperties.Get("_AcidProgress"));
					from = original;
				}
				void OnWillRenderObject()
				{
					skin.renderer.material.SetFloat(ShaderProperties.Get("_AcidProgress"), Math.Min(from, 1f));
					if (from < 1f)
					{
						from = Math.Min(1f, skin.renderer.material.GetFloat(ShaderProperties.Get("_AcidProgress")) + (0.5f * Time.deltaTime));
					}
				}

				void OnDestroy()
                {
					skin.renderer.material.SetFloat(ShaderProperties.Get("_AcidProgress"), skin.AcidProgress);
				}

			}
		}

	}
}

//Template by Polars Bear
