﻿using System;
using System.Collections;
using System.Reflection;
using UnityEngine;

namespace Mod
{
    public class SmolBoiSyringe : SyringeBehaviour
    {
        public const string name = "​<b></b>" + "</size>Smol Boi Syringe";
        public static void Load()
        {
            ModAPI.RegisterLiquid(SmolBoiSyringeSerum.ID, new SmolBoiSyringeSerum());

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Acid Syringe"),

                    NameOverride = name,
                    DescriptionOverride = "Syringe that makes the boi smol.",

                    CategoryOverride = ModAPI.FindCategory("Polars Bear"),
                    AfterSpawn = (Instance) => { Destroy(Instance.GetComponent<SyringeBehaviour>()); Instance.GetOrAddComponent<SmolBoiSyringe>(); }
                }
            );
            Mod.nailgun.SyringeNail(name, typeof(SmolBoiSyringe));
        }
        public override string GetLiquidID() => SmolBoiSyringeSerum.ID;
        public class SmolBoiSyringeSerum : Liquid
        {
            public const string ID = "​<b></b>" + "SMOL BOI SERUM";
            public const float TransferRate = 0f;


            public SmolBoiSyringeSerum()
            {
                Color = new UnityEngine.Color(1f,0.8f,0.6f);
            }
            public override void OnEnterLimb(LimbBehaviour limby)
            {
                limby.CirculationBehaviour.RemoveLiquid(this, limby.CirculationBehaviour.GetAmount(this));
                if (!limby.GetComponent<Injected>())
                {
                    limby.gameObject.AddComponent<Injected>();
                    limby.Person.transform.localScale *= 0.75f;
                    foreach (LimbBehaviour limb in limby.Person.Limbs)
                    {
                        limb.CirculationBehaviour.RemoveLiquid(this, limb.CirculationBehaviour.GetAmount(this));
                        limby.BaseStrength *= 0.75f;
                    }
                }
            }
            public override void OnExitContainer(BloodContainer container) { }
            public override void OnUpdate(BloodContainer container) { }
            public override void OnEnterContainer(BloodContainer container) { }
           
            private class Injected : MonoBehaviour
            {
                private float timer = 3f;
                void Update()
                {
                    timer -= Time.deltaTime;
                    if (timer <= 0)
                    {
                        Destroy(this);
                    }
                }
            }
        }

    }
}

//Author: Polars Bear
